# FN-CONNECT-PHP

![fn-connect-php](./fn-connect-php.PNG "fn-connect-php")

The project `fn-connect-php` is a template to demonstrate the use of the **365FarmNet Connect-API** and how integration into the 365FarmNet platform works.
It shows how to access existing fields of an account and whether your application has already been bought.
For more information about 365FarmNet Connect, please visit [developer.365farmnet.com](https://developer.365farmnet.com/).

fn-connect-php provides a very simple frontend project (written in **PHP** (5.3.2+) with the use of [Composer](https://getcomposer.org/)).
You will find nearly everything regarding its setup within [index.php](./src/index.php) file.

In particular the following topics of our process are covered by this example:

1. Being aware of different deployment stages.
2. How the partner id and partner secrets map to our stages.
3. Parsing the Connect-Token and validating its signature using our public keys.
4. Using different information from the Connect-Token to avoid hard coding.
5. Accessing information about the user and/or the module's state.
6. Creating the Partner-Token using the correct secret to access our APIs.
7. What kind of errors you should be aware of.

Please note this application is still in no way "production-ready".

## Getting Started

In order to get this project up and running you just need [Docker](https://www.docker.com/) and Docker-Compose to be installed on your machine.
Within this folder run

```shell
docker-compose up -d
```

to start a php ready system serving everything from `src` under [localhost:8080](http://localhost:8080).
Opening this URL within your browser should give you a running application showing a message there has been no Connect-Token given yet.

### Complete The Example

In order to receive a Connect-Token you basically need partner credentials (partner id and partner secrets).
However, we setup a so-called "developer partner" to be used for testing integrations into the 365FarmNet platform.

The developer partner's credentials are:

* partner key: `developer`
* partner id: `5726c2cf-143b-4834-aa54-24a1c1516a48`
* partner secret: `trsL26xTtFXgPHBJE8n4ZrN6R7fWfLrK`

and are already used in the example application.

Navigate to [365FarmNet DevCon](https://devcon.365farmnet.com) and create an account for free on our partner development stage.
Afterwards go to [Developer](https://devcon.365farmnet.com/365FarmNet/dist/index.html#/connect) and click `Developer Playground`.
There you should be able to change the URL to `http://localhost:8080` and see you got no fields (if you just created an account).

Congratulations you just accessed our [365FarmNet Connect-API](https://developer.365farmnet.com/)!

## Having Trouble

In case you are having trouble or feedback feel free to contact us anytime sending an email to [partner@365farmnet.com](mailto:partner@365farmnet.com).
